(function ($) {
	'use strict';

	$(document).ready(function () {

		vpc_lns_load_tcomponents();

	});


	window.vpc_lns_hide_component_selector = function (rules_groups) {
		if (rules_groups.result.scope == "component") {
			//$("#bx-pager a[data-id=" + rules_groups.result.apply_on + "]").addClass('disableClick');
			$("#bx-pager a[data-id=" + rules_groups.result.apply_on + "]").addClass('disableClick');
			$("#vpc-container div.vpc-component[data-component_id=" + rules_groups.result.apply_on + "]").find("option").prop('selected', false);
			$("#" + rules_groups.result.apply_on).find("option").removeAttr('selected');
		}
	}
	window.vpc_lns_show_component_selector = function (rules_groups) {
		if (rules_groups.result.scope == "component") {
			$("#bx-pager a[data-id=" + rules_groups.result.apply_on + "]").removeClass('disableClick');
		}
	}

	function vpc_lns_load_tcomponents() {

		window.vpc_lns_slider = $('.VPC_ln_Skin .components-slider').bxSlider({
			pagerCustom: '#bx-pager',
			controls: false,
			infiniteLoop: false,
			touchEnabled: false,
			onSliderLoad: function () {
				$(".VPC_ln_Skin .components-slider").css("visibility", "visible");
				$(".VPC_ln_Skin .components-slider").css("height", "auto");

				wp.hooks.addAction('vpc.hide_options_or_component','vpc-lns', vpc_lns_hide_component_selector);
				wp.hooks.addAction('vpc.show_options_or_component','vpc-lns', vpc_lns_show_component_selector);

				if (typeof vpc != 'undefined') {
					$(vpc.vpc_selected_items_selector).each(function () {
						vpc_apply_rules($(this));
					});

					if (vpc.wvpc_conditional_rules.length == 0) {
						vpc_build_preview();
					}
				}

				lns_layout_setup();
				$(window).on('orientationchange resize', function () {
					lns_layout_setup();
				});

			},
		});

		window.count_index = $('#bx-pager a').length;

		if (count_index == 1) {
			$('.VPC_ln_Skin .gonext').addClass('disableClick');
		}

		$('.VPC_ln_Skin .goprev').addClass('disableClick');


		$('.VPC_ln_Skin .gonext').click(function () {

			$('.VPC_ln_Skin .goprev').removeClass('disableClick');

			var index = vpc_lns_slider.getCurrentSlide() + 1;
			lns_slide_nxt_component(vpc_lns_slider, index, count_index);

			if (vpc_lns_slider.getCurrentSlide() == count_index - 1) {
				$('.VPC_ln_Skin .gonext').addClass('disableClick');
			}

			return false;
		});

		$('.VPC_ln_Skin .goprev').click(function () {

			$('.VPC_ln_Skin .gonext').removeClass('disableClick');

			var index = vpc_lns_slider.getCurrentSlide() - 1;
			lns_slide_pvs_component(vpc_lns_slider, index, count_index);

			if (vpc_lns_slider.getCurrentSlide() == 0) {
				$('.VPC_ln_Skin .goprev').addClass('disableClick');
			}

			return false;
		});

	}

	function lns_layout_setup() {
		if (window.matchMedia("(min-width: 1024px)").matches) {
			lns_onload_setup();
			lns_scroll_settings();
			$(document).on("change", ".vpc-options input,.vpc-options select", function (e) {
				setTimeout(function () {
					lns_scroll_settings();
				}, 50)
			})
		}
	}

	window.lns_onload_setup = function () {
		var pager_height = $('.VPC_ln_Skin #vpc-components #bx-pager').innerHeight();
		$('.VPC_ln_Skin #configurator-wrap').css('height', pager_height + 2);
	}

	function lns_slide_nxt_component(slider, index, count_index) {
		while (index < count_index) {
			if (!$('.VPC_ln_Skin #bx-pager a[data-slide-index="' + index + '"]').hasClass('disableClick')) {
				slider.goToSlide(index);
				var componentID = $('.VPC_ln_Skin #bx-pager a[data-slide-index="' + index + '"]').attr("data-id");
				component_highlight(componentID);
				break;
			}
			index++;
		}
	}

	function lns_slide_pvs_component(slider, index, count_index) {
		while (index >= 0) {
			if (!$('.VPC_ln_Skin #bx-pager a[data-slide-index="' + index + '"]').hasClass('disableClick')) {
				slider.goToSlide(index);
				var componentID = $('.VPC_ln_Skin #bx-pager a[data-slide-index="' + index + '"]').attr("data-id");
				component_highlight(componentID);
				break;
			}
			index--;
		}
	}

	function component_highlight(ID) {

		$("#vpc-preview img, .vpc-preview img").removeClass("current");
		$("#vpc-preview img[data-component-id='" + ID + "'], .vpc-preview img[data-component-id='" + ID + "']").addClass("current");

	}

	window.lns_scroll_settings = function () {
		var element = $('.VPC_ln_Skin #vpc-preview-container'), element2 = $('.VPC_ln_Skin .vpc-component .vpc-component-content');
		window.element3 = $('.VPC_ln_Skin #components-slider-nav-desktop');

		var elementY, fullHeight;
		window.limitY = 0;

		if (element.length) {
			elementY = element.offset().top;
			fullHeight = element.innerHeight() + 20; //  20 for slider nav margin top
		}

		if (element3.length) {
			limitY = element3.offset().top;
		}


		var scrollTop;
		// Space between element and top of screen (when scrolling)
		var topMargin = 0;

		// Should probably be set in CSS; but here just for emphasis
		element.css('position', 'relative');


		if ($('.VPC_ln_Skin #vpc-preview-container').length > 0) {
			var preview_height = $('.VPC_ln_Skin #vpc-preview-container').innerHeight();
			var pager_height = $('.VPC_ln_Skin #vpc-components #bx-pager').innerHeight();

			$('.VPC_ln_Skin .components-slider .vpc-component, .VPC_ln_Skin #vpc-components .bx-wrapper').css('height', pager_height + 2);

			if (preview_height >= pager_height) {
				$('.VPC_ln_Skin .components-slider .vpc-component, .VPC_ln_Skin #vpc-components .bx-wrapper').css('height', preview_height + 2);
				$('.VPC_ln_Skin #configurator-wrap').css('height', preview_height + 4);
			}

			if (pager_height < preview_height) {
				$('.VPC_ln_Skin #vpc-components #bx-pager').css('height', preview_height + 2);
			}

			if (pager_height > preview_height) {
				$('.VPC_ln_Skin #configurator-wrap').css('height', pager_height + 2);
			}
		}


		$(window).on('scroll', function (event) {
			scrollTop = $(window).scrollTop();


			if (element.length && element2.length) {
				if (scrollTop < elementY) {
					element.stop(false, false).animate({
						top: 0
					}, 300);
					element2.stop(false, false).animate({
						top: 0
					}, 300);
				}
				if (scrollTop > elementY && (scrollTop + fullHeight + topMargin) < limitY) {
					element.stop(false, false).animate({
						top: scrollTop - elementY + topMargin
					}, 300);
					element2.stop(false, false).animate({
						top: scrollTop - elementY + topMargin
					}, 300);
				}
				if (limitY < (scrollTop + fullHeight + topMargin)) {
					element.stop(false, false).animate({
						top: 'auto'
					}, 300);
					element2.stop(false, false).animate({
						top: 'auto'
					}, 300);
				}
			}

		});

		$('.VPC_ln_Skin #bx-pager a').on('click', function () {

			$('.VPC_ln_Skin .gonext').removeClass('disableClick');
			$('.VPC_ln_Skin .goprev').removeClass('disableClick');

			var componentID = $(this).attr("data-id");

			if ($(this).attr("data-slide-index") == count_index - 1) {
				$('.VPC_ln_Skin .gonext').addClass('disableClick');
			}

			if ($(this).attr("data-slide-index") == 0) {
				$('.VPC_ln_Skin .goprev').addClass('disableClick');
			}

			component_highlight(componentID);

		});

		$('.VPC_ln_Skin #vpc-components .vpc-options label.custom').on('click', function () {

			if (window.matchMedia("(min-width: 240px) and (max-width: 1024px)").matches) {
				$('.VPC_ln_Skin #vpc-components').addClass('ln-hidden');
			}

		});

		$('.VPC_ln_Skin #components-slider-nav-desktop a').on('click', function () {

			$('.VPC_ln_Skin #vpc-components').removeClass('ln-hidden');

		});


		/*****Displaying the default view linked to the component by clicking on menus 1, 2 ...*****/
		if (typeof active_views != "undefined") {
			$(document).on("click", "#bx-pager a", function (e) {
				var comp_id = $(this).data('id');
				var view_to_focus = $("#" + comp_id).data('component-focus');
				if (typeof view_to_focus !== 'undefined' && view_to_focus !== "none") {
					$('#mva-bx-pager .bx-pager ').find("a[data-view=" + view_to_focus + "]").trigger("click");
				}
			});
		}
	}


})(jQuery);
