<?php
/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              https://www.orionorigin.com/product/lom-nava-skin/?utm_source=Installed+pro+plugin&utm_medium=Source+code&utm_campaign=VPC-LNS
 * @since             1.0.0
 * @package           Vpc_Lns
 *
 * @wordpress-plugin
 * Plugin Name:       Visual Products Configurator Lom-Nava Skin
 * Plugin URI:        https://www.orionorigin.com/product/lom-nava-skin/?utm_source=Installed+pro+plugin&utm_medium=Source+code&utm_campaign=VPC-LNS
 * Description:       A beautiful mutliple steps skin that will instantly enhance the look and feel of your configurator.
 * Version:           3.1.2
 * Author:            ORION
 * Author URI:        https://www.orionorigin.com/?utm_source=Installed+pro+plugin&utm_medium=Author+URI&utm_campaign=VPC-LNS
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       vpc-lns
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}
define( 'VPC_LNS_URL', plugins_url( '/', __FILE__ ) );
define( 'VPC_LNS_DIR', dirname( __FILE__ ) );

define( 'VPC_LNS_VERSION', '3.1.2' );

define( 'VPC_LNS_MAIN_FILE', 'visual-product-configurator-lom-nava-skin/vpc-lns.php' );
define( 'VPC_LNS_NAME', 'Visual Product Configurator Lom Nava Skin' );

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-vpc-lns-activator.php
 */
function activate_vpc_lns() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-vpc-lns-activator.php';
	Vpc_Lns_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-vpc-lns-deactivator.php
 */
function deactivate_vpc_lns() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-vpc-lns-deactivator.php';
	Vpc_Lns_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_vpc_lns' );
register_deactivation_hook( __FILE__, 'deactivate_vpc_lns' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-vpc-lns.php';
require plugin_dir_path( __FILE__ ) . 'skins/class-vpc-ln-left-sidebar-skin.php';
require plugin_dir_path( __FILE__ ) . 'skins/class-vpc-ln-right-sidebar-skin.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_vpc_lns() {

	$plugin = new Vpc_Lns();
	$plugin->run();
}

run_vpc_lns();
